<script lang="ts" setup>
import { pathToID } from '@/utils/pathToID';

const { path } = useRoute();

const { locale } = useI18n();
const { data } = await useAsyncData('search', () =>
  queryContent(`/${locale.value.toLocaleLowerCase()}/search`).findOne(),
);

if (!data.value) {
  throw createError({
    statusCode: 404,
    message: `Page not found in the content library: ${path}`,
  });
}

// Generic SEO configuration
useGitlabSeo(data.value.seo);

// Use a specific layout, use the "default" one if undefined
setPageLayout(data.value.config?.layout);

// Error handler for better debugging
useErrorHandler();

// Enable AOS for the current page
if (data.value.config?.enableAnimations) {
  useAOS();
} else {
  if (import.meta.client) {
    document.body.classList.add('aos-disabled');
  }
}

if (!data.value.content) {
  throw createError({
    statusCode: 500,
    message: `Page is missing the "content" attribute: ${path}`,
  });
}

const resolvedTemplate = await import(`@/components/templates/${data.value.config?.template || 'Common'}.vue`);
</script>

<template>
  <div :id="pathToID(path)">
    <component :is="resolvedTemplate.default" :content="data?.content" />
  </div>
</template>
